Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Friends | List of all members
FfmpegAudioCursor Class Reference

A stream that generates a sequence of audio samples. More...

`#include "ffmpegAudioCursor.h"`

Inheritance diagram for FfmpegAudioCursor:

## Public Member Functions
| FfmpegAudioCursor (FfmpegAudio *src)
| xxx
virtual | ~FfmpegAudioCursor ()
| xxx
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
virtual void | read_samples (int n, int16_t *data)
| Read audio samples from the stream.
virtual void | seek (double offset)
| Seeks to a target location.
Public Member Functions inherited from MovieAudioCursor
| MovieAudioCursor (MovieAudio *src)
| This constructor returns a null audio stream — a stream of total silence, at 8000 samples per second.
bool | aborted () const
int | audio_channels () const
int | audio_rate () const
bool | can_seek () const
bool | can_seek_fast () const
double | length () const
| PT (MovieAudio) get_source() const
std::string | read_samples (int n)
| Read audio samples from the stream and returns them as a string.
void | read_samples (int n, Datagram *dg)
| Read audio samples from the stream into a Datagram.
virtual int | ready () const
| Returns the number of audio samples that are ready to read.
void | skip_samples (int n)
double | tell () const
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | fillin (DatagramIterator &scan, BamReader *manager)
| This internal function is intended to be called by each class's make_from_bam() method to read in all of the relevant data from the BamFile for the new object.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from MovieAudioCursor
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Friends
class | FfmpegAudio

## Additional Inherited Members
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A stream that generates a sequence of audio samples.

Definition at line 39 of file ffmpegAudioCursor.h.

## Constructor & Destructor Documentation

## ◆ FfmpegAudioCursor()

FfmpegAudioCursor::FfmpegAudioCursor | ( | FfmpegAudio * | src | ) |

xxx

Definition at line 45 of file ffmpegAudioCursor.cxx.

References MovieAudioCursor::MovieAudioCursor().

## ◆ ~FfmpegAudioCursor()

FfmpegAudioCursor::~FfmpegAudioCursor | ( |  | ) |
| virtual

xxx

Definition at line 223 of file ffmpegAudioCursor.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle FfmpegAudioCursor::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from MovieAudioCursor.

Definition at line 86 of file ffmpegAudioCursor.h.

## ◆ get_class_type()

static TypeHandle FfmpegAudioCursor::get_class_type | ( |  | ) |
| inline static

Definition at line 75 of file ffmpegAudioCursor.h.

## ◆ get_type()

virtual TypeHandle FfmpegAudioCursor::get_type | ( |  | ) | const
| inline virtual

Reimplemented from MovieAudioCursor.

Definition at line 83 of file ffmpegAudioCursor.h.

## ◆ init_type()

static void FfmpegAudioCursor::init_type | ( |  | ) |
| inline static

Definition at line 78 of file ffmpegAudioCursor.h.

## ◆ read_samples()

void FfmpegAudioCursor::read_samples | ( | int | n,
|  | int16_t * | data )
| virtual

Read audio samples from the stream.

N is the number of samples you wish to read. Your buffer must be equal in size to N * channels. Multiple-channel audio will be interleaved.

Reimplemented from MovieAudioCursor.

Definition at line 485 of file ffmpegAudioCursor.cxx.

Referenced by seek().

## ◆ seek()

void FfmpegAudioCursor::seek | ( | double | t | ) |
| virtual

Seeks to a target location.

Afterward, the packet_time is guaranteed to be less than or equal to the specified time.

Reimplemented from MovieAudioCursor.

Definition at line 455 of file ffmpegAudioCursor.cxx.

References read_samples().

## Friends And Related Symbol Documentation

## ◆ FfmpegAudio

friend class FfmpegAudio
| friend

Definition at line 40 of file ffmpegAudioCursor.h.

The documentation for this class was generated from the following files:

- panda/src/ffmpeg/ffmpegAudioCursor.h
- panda/src/ffmpeg/ffmpegAudioCursor.cxx